
/* i_BTST, i_BCHG, i_BCLR, i_BSET */

    case i_BTST:
    case i_BCHG:
    case i_BCLR:
    case i_BSET:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      outval = 4;

      switch (iib->size) {
      case sz_byte:
        OPCODE = rlwinm(3, srcval, 0, 29, 31);
        OPCODE = li(5, 1);
        OPCODE = rlwnm(5, 5, 3, 0, 31);
        break;
      case sz_long:
        OPCODE = rlwinm(3, srcval, 0, 27, 31);
        OPCODE = li(5, 1);
        OPCODE = rlwnm(5, 5, 3, 0, 31);
        break;
      default:
        printf("i_Bxxx: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      if (ipc->set & IIB_FLAG_Z) {
        OPCODE = srw(outval, dstval, 3);
        OPCODE = xori(outval, outval, 1);
        OPCODE = rlwimi(SRREG, outval, 18, 13, 13); /* ZFLAG */
      }

      switch(iib->mnemonic) {
      case i_BTST:
        break;
      case i_BCHG:
        OPCODE = xor(outval, dstval, 5);
        compile_eastore(iib, ipc, tp_dst, dstreg, outval);
        break;
      case i_BCLR:
        OPCODE = andc(outval, dstval, 5);
        compile_eastore(iib, ipc, tp_dst, dstreg, outval);
        break;
      case i_BSET:
        OPCODE = or(outval, dstval, 5);
        compile_eastore(iib, ipc, tp_dst, dstreg, outval);
        break;
      default:
        printf("i_Bxxx: Invalid instruction\n");
        instr_error = 1;
      }
      break;

