/* Define if your processor stores words with the most significant
   byte first (like Motorola and SPARC, unlike Intel and VAX).  */
#define WORDS_BIGENDIAN

/* The number of bytes in a unsigned char.  */
#define SIZEOF_UNSIGNED_CHAR 1

/* The number of bytes in a unsigned int.  */
#define SIZEOF_UNSIGNED_INT 4

/* The number of bytes in a unsigned short.  */
#define SIZEOF_UNSIGNED_SHORT 2

/* The number of bytes in a unsigned long.  */
#define SIZEOF_UNSIGNED_LONG 4

/* The number of bytes in a unsigned long long.  */
#define SIZEOF_UNSIGNED_LONG_LONG 8

/* Return type of the signal handler */
#define RETSIGTYPE void

/* Undefine if your processor can access 32 bits of data aligned to 16 bits */
#undef ALIGNLONGS

/* Define for direct ram writes (faster) */
#define DIRECTRAM

/* Define to use the portable C mz80 z80 emulation */
#define CMZ80

/* JPEG features */
#undef JPEG

/* Define to turn off all logging */
#define NOLOGGING

/* Define your processor type if it's here */
#undef PROCESSOR_SPARC
#undef PROCESSOR_ARM
#undef PROCESSOR_INTEL
#define PROCESSOR_PPC

/* Version number of package */
#define VERSION "0.35"

